#include "systemc.h"
#include "tlm.h"
#include "tlm_utils/simple_initiator_socket.h"
#include "tlm_utils/simple_target_socket.h"

SC_MODULE(Initiator) {
SC_HAS_PROCESS(Initiator);
	tlm_utils::simple_initiator_socket<Initiator> socket;

	Initiator(sc_module_name);

	void behav(); 

};


SC_MODULE(TOP) {

	tlm_utils::simple_target_socket<TOP> socket;

	Initiator init;

	SC_CTOR(TOP); 

	void b_transport( tlm::tlm_generic_payload& trans, sc_time& delay ); 
	

};


